ds_udf <-
function(x,r,fraction.fb,p){
#Step 1: Embed time series
   results.embed_udf<-embed_udf(x)
   d<-results.embed_udf[[1]];t<-results.embed_udf[[2]]
   m<-results.embed_udf[[3]];Mx<-results.embed_udf[[4]]

#Step 2: Set radius parameter required by 'd2(tseriesChaos)' and lyap_k(tseriesChaos)
   
   library(fields)
   dist<-rdist(Mx)  #rdist(fields) [euclidean distances in embedded time series matrix]
   Radius<-r*max(dist)  #max(base) [Radius proportionate to 'dist' by 'r']

#Step 3: Compute discriminating statistics

   #Step 3a:  Compute Correlation Dimension

   #Compute CI for m up to m_max iterating over radius.
   #Estimate correlation dimension as the slope of the linear segment in the 
   #logCI(eps)-log(eps) plot for each m.

   library(tseriesChaos)
   m_max=6
   d2.out<-d2(x,m_max,d,t,eps.min=Radius)
   eps<-d2.out[1:100]   #gives eps (radius) values used
   eps.log<-log(eps)
   library(mda)  #contains mars regression routine
   
   cd.m<-matrix(0,m_max,1)
   for (i in 1:m_max){
      index1=(i*100)+1  #indices to call CI from d2.out
      index2=(i+1)*100
      CI<-d2.out[index1:index2]
      CI.log<-log(CI)   #log(base)
      ind<-eps.log;dep<-CI.log
      #Calculate slope of linear portion of CI.log~eps.log graph
      CI.cd<-mars_udf(ind,dep)
      cd.m[i,1]<-CI.cd
   }  #end iloop
  
   cd.m #correlation dimensions for increasing embedding dimensions
   cd<-cd.m[6]

   #Step 3b:  Compute Maximum Lyapunov Exponent

      #Step 3b(1): Evaluate log(stretching factor) through time

   s<-20     #s is parameter required by lyap_k(tseriesChaos) and gives the number 
             #of iterations (time periods over which to compute Lyapunov Exponent)
   
   #lyap_k(tseriesChaos)--evaluates log(stretching factor)through time
   LE.s<-lyap_k(x,m,d,t,k=1,ref=10,s,eps=Radius) 
   LE.s<-LE.s[which(LE.s!=-Inf)]  #remove '-Inf' elements from beginning of 'LE.s'
   s<-length(LE.s)  #make 's' the same length as 'LE.s'
   times<-1:s
      
      #Step 3b(2): Estimate maximum Lyapunov exponent as the slope of the linear segment in 
             #the LE.s-times plot gives an estimate of the maximum
   ind<-times;dep<-LE.s
   max.LE<-mars_udf(ind,dep)

   #Step 3c: Prediction skill

   results.predict.is_udf<-predict.is_udf(x,fraction.fb,p)
   mnse.ssa<-results.predict.is_udf[[1]]
   val.points<-results.predict.is_udf[[2]]
   pred.points<-results.predict.is_udf[[3]]
   
#Step 5:  Results

   results.ds_udf<-list(cd,cd.m,max.LE,LE.s,m,d,Mx,mnse.ssa,val.points,pred.points) 
   return(results.ds_udf)
}
