mars_udf <-
function(ind,dep){

   library(mda)
   data<-cbind(ind,dep)  #prepare data to call up in mars regression
   data<-as.data.frame(data)
   mars.out<-mars(ind,dep)  #run mars regression library(mda)
   cuts<-mars.out[10]  #call up 'cut-points list' from mars output
   cuts<-matrix(unlist(cuts),ncol=1,byrow=TRUE)  #unlist output to use cuts as input 
   ind.cut<-ind[1:sum(ind<cuts[2])] #restrict data to that below second cut
   dep.cut<-dep[1:length(ind.cut)]  #i.e., the 'linear' portion of curve
   dep.reg<-lm(dep.cut~ind.cut)  #run linear reg for slope of linear portion
   dep.reg<-matrix(unlist(dep.reg),ncol=1,byrow=TRUE) #unlist regression output
   slope.linear<-dep.reg[2]  #isolate slope from regression output
   slope.linear<-matrix(unlist(slope.linear),ncol=1,byrow=TRUE) #unlist slope for use as input
   return(slope.linear)
}
