predict.is_udf <-
function(x,fraction.fb,p){ #Nash Sutcliffe parameter
#Step 1: Embed time series
   
   library(tseriesChaos)
   results.embed_udf<-embed_udf(x)
   d<-results.embed_udf[[1]];m<-results.embed_udf[[3]]
   Mx<-results.embed_udf[[4]]
   
#Step 2:  Number of rows in forecast and validation bases

   Mx.fb.rows<-fraction.fb*nrow(Mx);Mx.fb.rows<-round(Mx.fb.rows)
   Mx.val.rows<-nrow(Mx)-Mx.fb.rows 

      #Step 2b: Calculate nearest points to D(t) and prediction of D(t+1)
 
   hold.diff<-matrix(0,(Mx.val.rows-1),1)
   hold.val<-matrix(0,(Mx.val.rows-1),1)
   hold.pred<-matrix(0,(Mx.val.rows-1),1)

   #Start index from Mx.fb.rows which gives forecasting base of embedded data
   #matrix (Mx.fb) as the first matrix in the loop. End index with penultimate 
   #row of embedded data matrix Mx which is last row used for prediction (the
   #final row is used for validation). The loop adds a row from Mx to Mx.fb
   #at each iteration.

   for(i in 1:(Mx.val.rows-1)){ 
      Mx.fb<-Mx[1:((Mx.fb.rows+i)-1),]
      ref.point<-nrow(Mx.fb) #ref point D(t) is last row in forecasting base
      library(fields)
      dist<-rdist(Mx.fb)
      dist.ref<-dist[,ref.point];sc<-max(dist.ref);dist.ref.sc<-dist.ref/sc
      
      #Order distances from closest to farthest from ref.pnt         
      o<-order(dist.ref.sc) 
      #remove reference row
      remove<-which(o==nrow(Mx.fb));o1<-o[-remove]
      o2<-o1[1:(m+1)];o2<-na.omit(o2) #Indicies of m+1 smallest distances from ref.row.
      o.pred<-o2+1  #Increment neighboring points by 1 period for use in prediction
      #print("o2");print(o2)

      dist.ordered<-dist.ref.sc[o2] #ordered distances       
      #print("dist.ordered"); print(dist.ordered)     
      
      Mx.pred<-Mx.fb[o.pred,]  #points on attractor used for prediction
      val.point<-Mx[nrow(Mx.fb)+1,]  #validation point (1st point in validation base)
      
      #Compute Df(t+1). Compute weights as function of distances on Mx.fb
      u.denom<-dist.ordered[1] #distance from ref.point to nearest neighbor                                  
      #print("u.denom");print(u.denom)

         hold<-matrix(0,(m+1),1)
         for(j in 1:(m+1)){  #summands in w.demon 
           #print("j");print(j)    
           u.vector<-exp(-dist.ordered[j]/u.denom)  
           #print("u.vector");print(u.vector)
           #print("dist.ordered[j]");print(dist.ordered[j])
           hold[j,1]<-u.vector
         } #end loop j

         u.vector<-hold[1:(m+1)]  
         #print("u.vector");print(u.vector)
         w.denom<-sum(u.vector)         
         w.vector<-u.vector/w.denom
         #print("w.vector");print(w.vector)
         pred.point<-w.vector%*%Mx.pred  #estimated Mx row
         #print("val.point");print(val.point);print("pred.point");print(pred.point)
      
      hold.val[i,]<-val.point[1]
      hold.pred[i,]<-pred.point[1]
      }  #end iloop
   val.points<-hold.val;pred.points<-hold.pred
   
#Step 3: Calculate modified Nash-Sutcliffe model efficiency
   mnse.ssa<-mnse_udf(val.points,pred.points,p)

#Step 4: Results
   results.predict.is<-list(mnse.ssa,val.points,pred.points,Mx,m)
   return(results.predict.is)

}
