surr_LE_udf<-function(x,method,k,alpha,one.sided,r,slope.LE){

library(fractal)

######################
#Number of surrogates#
######################  
if(one.sided){nsurr=(k/alpha)-1} else {nsurr=(2*k/alpha)-1}

######################
#Set surrogate method#
######################
method=method 

#####################
#Generate surrogates#
#####################
LE.surr<-matrix(0,nsurr,1)
for (i in 1:nsurr) {
  surr.out<-surrogate(x,method)
  surr<-surr.out[1:length(surr.out)]
  
  results.ds_udf<-ds_udf(surr,r,fraction.fb,p)
  LE.surr[i,1]<-results.ds_udf[[3]]
 
  } #endloop i

surr.LE<-LE.surr
surr.LE.mean<-mean(surr.LE);surr.LE.sd<-sqrt(var(surr.LE))

#Establish k smallest and largest values
LE.low<-sort(surr.LE)[k];LE.high<-sort(surr.LE)[length(surr.LE)-(k-1)]
  
results.surr_LE<-list(LE.low,LE.high,surr.LE.mean,surr.LE.sd)
return(results.surr_LE)
}  #end user-defined function
