surr_cd_udf<-function(x,method,k,alpha,one.sided,r,slope.cd){

library(fractal)

######################
#Number of surrogates#
######################  
if(one.sided){nsurr=(k/alpha)-1} else {nsurr=(2*k/alpha)-1}

######################
#Set surrogate method#
######################
method=method 

#####################
#Generate surrogates#
#####################
cd.surr<-matrix(0,nsurr,1)
for (i in 1:nsurr) {
  surr.out<-surrogate(x,method)
  surr<-surr.out[1:length(surr.out)]
  
  results.ds_udf<-ds_udf(surr,r,fraction.fb,p)
  cd.surr[i,1]<-results.ds_udf[[1]]
 
  } #endloop i

surr.cd<-cd.surr
surr.cd.mean<-mean(surr.cd);surr.cd.sd<-sqrt(var(surr.cd))

#Establish k smallest and largest values
cd.low<-sort(surr.cd)[k];cd.high<-sort(surr.cd)[length(surr.cd)-(k-1)]
  
results.surr_cd<-list(cd.low,cd.high,surr.cd.mean,surr.cd.sd)
return(results.surr_cd)
}  #end user-defined function
