surr_np_udf<-function(x,method,k,alpha,one.sided,r,fraction.fb,p){

library(fractal)

######################
#Number of surrogates#
######################  
if(one.sided){nsurr=(k/alpha)-1} else {nsurr=(2*k/alpha)-1}

######################
#Set surrogate method#
######################
method=method 

#####################
#Generate surrogates#
#####################
np.surr<-matrix(0,nsurr,1)
for (i in 1:nsurr) {
  surr.out<-surrogate(x,method)
  surr<-surr.out[1:length(surr.out)]
  
  results.ds_udf<-ds_udf(surr,r,fraction.fb,p)
  np.surr[i,1]<-results.ds_udf[[8]]
 
  } #endloop i

surr.np<-np.surr
surr.np.mean<-mean(surr.np);surr.np.sd<-sqrt(var(surr.np))

#Establish k smallest and largest values
np.low<-sort(surr.np)[k];np.high<-sort(surr.np)[length(surr.np)-(k-1)]
  
results.surr_np<-list(np.low,np.high,surr.np.mean,surr.np.sd)
return(results.surr_np)
}  #end user-defined function
